/*
 ******************************* Creazione file *******************************
 *-------------------------------------|--------------------------------------*
 * Creatore : Marco Savegnago             	Data di creazione : 23/12/98
 * Codice   :
 *
 * Definition of Message Queue Object
 *
 ******************************* Revisione file *******************************
 *-------------------------------------|--------------------------------------*
 * Revisore : 								Data di revisione :
 * Versione :
 *
 * Note:
 *
 */

#include	"stdafx.h"

TMSGQueue::TMSGQueue(HWND	hWnd, DWORD	dw_MinMsg,	DWORD	dw_MaxMsg, DWORD	dw_Size, BOOL	b_start)
:
	hWindow(hWnd),
	dw_minMessage(dw_MinMsg),
	dw_maxMessage(dw_MaxMsg),
	next(NULL),
	b_running(b_start)
{
	msgs	=	new	MSG[dw_limit=dw_Size+1];
	Flush();
}

TMSGQueue::~TMSGQueue()
{
	if(msgs!=NULL)
		delete	msgs;
}
	
bool	TMSGQueue::Insert(const	MSG& msg)
{
//	Questo velocizza il programma in quanto la funzione viene richiamata 
//	solo dopo un test IsFull();

//	if(IsFull())
//		return false;
	
	TLock lock(this);

	msgs[dw_head]	=	msg;

	if(++dw_head == dw_limit)
		dw_head = 0;

	return true;
}

bool	TMSGQueue::Remove(MSG& msg, BOOL	b_Remove)
{
//	Questo velocizza il programma in quanto la funzione viene richiamata 
//	solo dopo un test IsEmpty() o GetCount();

//	if(IsEmpty())
//		return false;

    TLock lock(this);

	msg	= msgs[dw_tail];

	if(b_Remove && ++dw_tail == dw_limit)
		dw_tail = 0;

	return	true;
}

bool	TMSGQueue::IsValidWindow(HWND hWnd)
{
	if(hWindow && hWnd && (hWindow == hWnd) )
		return true;

	return false;
}

bool	TMSGQueue::IsValidMessage(UINT Message)
{
	if((Message >= dw_minMessage) && (Message <= dw_maxMessage))
		return true;

	return false;
}
